// checksum 0xa193 version 0x30001
/*
  This file was generated by the Mobile Qt Application wizard of Qt Creator.
  MainWindow is a convenience class containing mobile device specific code
  such as screen orientation handling.
  It is recommended not to modify this file, since newer versions of Qt Creator
  may offer an updated version of it.
*/
#include <QDeclarativeView>
#include <QDeclarativeContext>
#include <QtDebug>

#ifdef Q_WS_MAEMO_5
#include <QMaemo5ValueButton>
#include <QMaemo5ListPickSelector>
#include <QMenuBar>
#include <QMaemo5InformationBox>

#include <QGeoPositionInfoSource>
#include <QGeoCoordinate>
#endif

#include "mainwindow.h"
#include "ui_mainwindow.h"
//#include "mainwidget.h"        ////////////// osm map widget

#include <QtCore/QCoreApplication>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
{
    this->setWindowTitle("AesyPig");
    menuBar = new QMenuBar(this);
    menuBar->setObjectName(QString::fromUtf8("menuBar"));
    this->setMenuBar(menuBar);
//    ui->setupUi(this);
    //////////////////////////////////////////////////////  initial qml viewer
    qmlView = new QDeclarativeView;
    QDeclarativeContext *context = qmlView->rootContext();
    context->setContextProperty("mainApp", this);
    qmlView->setSource(QUrl("qrc:/mainmenu.qml"));
    //qmlView->setSource(QUrl("qrc:/browser.qml"));
    this->setCentralWidget(qmlView);

    //////////////////////////////////////////////////////  initial osm map widget to null
//    this->osm = NULL;
    ////////////////////////

    QAction *mainmenu = new QAction(tr("main menu"),this);
    QMainWindow::menuBar()->addAction(mainmenu);
    connect(mainmenu,SIGNAL(triggered()),this,SLOT(toMainmenu()));

    //////////////////////////////////////////////////////  GPS
#ifdef Q_WS_MAEMO_5
    source = QGeoPositionInfoSource::createDefaultSource(this);
        if (source)
        {
            connect(source, SIGNAL(positionUpdated(QGeoPositionInfo)),this, SLOT(positionUpdated(QGeoPositionInfo)));
            //connect(ui->pushButton, SIGNAL(clicked()),this, SLOT(positionUpdated(QGeoPositionInfo)));
            source->setUpdateInterval(5000);
            source->startUpdates();
        }
#endif

#ifdef Q_WS_MAEMO_5
    QMaemo5InformationBox::information(this,"Welcome!",QMaemo5InformationBox::DefaultTimeout);
#endif
}

void MainWindow::toMainmenu()
{
//    qDebug() << "to main menu";
//    if (this->centralWidget() == this->osm)
//    {
//        qDebug() << "inside the mainmenu if" ;
//        delete this->osm;
//        this->qmlView = new QDeclarativeView;
//        QDeclarativeContext *context = qmlView->rootContext();
//        context->setContextProperty("mainApp", this);
//        this->setCentralWidget(this->qmlView);
//        qDebug() << "behind the set centralwidget" ;
//    }
    this->qmlView->setSource(QUrl("qrc:/mainmenu.qml"));
    qDebug() << "outside the mainmenu if" ;
}

void MainWindow::toDrivemap()
{
    qmlView = new QDeclarativeView;
    QDeclarativeContext *context = qmlView->rootContext();
    context->setContextProperty("mainApp", this);
    qDebug() << "toDrivemap" ;
    this->qmlView->setSource(QUrl("qrc:/qdrivemap.qml"));
    this->setCentralWidget(qmlView);
    qDebug() << "toDrivemap" ;
}

void MainWindow::toBusmap()
{
    qmlView = new QDeclarativeView;
    QDeclarativeContext *context = qmlView->rootContext();
    context->setContextProperty("mainApp", this);
    qDebug() << "toBusmap" ;
    this->qmlView->setSource(QUrl("qrc:/browser.qml"));
    this->setCentralWidget(qmlView);
    qDebug() << "toBusmap" ;
}

void MainWindow::toOsmmap()
{
//    if (!this->osm)
//    {
//        this->osm = new MainWidget();
//        qDebug() << "osm is not null" ;
//    }
//    this->osm = new MainWidget(this);
//    this->setCentralWidget(this->osm);
//    qDebug() << "to osm map" ;
}

#ifdef Q_WS_MAEMO_5
void MainWindow::positionUpdated(const QGeoPositionInfo &info)
{
    this->m_latitude = info.coordinate().latitude();
    this->m_longitude = info.coordinate().longitude();
//    bool isosm = (this->centralWidget() == this->osm);
//    qDebug() << "using osm?  :  " << isosm ;
//    if (isosm)
//    {
//        //osm->m_map->centerOnGeoPos(this->m_longitude , this->m_latitude);
//        osm->centerMap(this->m_longitude , this->m_latitude);
//    }
    //this->m_latitude.setNum(info.coordinate().latitude());
    //this->m_longitude.setNum(info.coordinate().longitude());
    //qDebug() << this->m_latitude << this->m_longitude ;
}
#endif

qreal MainWindow::getlatitude()  const
{
    return this->m_latitude;
}

qreal MainWindow::getlongtitude()  const
{
    return this->m_longitude;
}

void MainWindow::useInfobox(QString info)
{    
#ifdef Q_WS_MAEMO_5
    QMaemo5InformationBox::information(this, info ,QMaemo5InformationBox::DefaultTimeout);
#endif
}

MainWindow::~MainWindow()
{
//    delete ui;
}


void MainWindow::setOrientation(ScreenOrientation orientation)

{

#if defined(Q_OS_SYMBIAN)
    // If the version of Qt on the device is < 4.7.2, that attribute won't work
    if (orientation != ScreenOrientationAuto) {
        const QStringList v = QString::fromAscii(qVersion()).split(QLatin1Char('.'));
        if (v.count() == 3 && (v.at(0).toInt() << 16 | v.at(1).toInt() << 8 | v.at(2).toInt()) < 0x040702) {
            qWarning("Screen orientation locking only supported with Qt 4.7.2 and above");

            return;
        }
    }
#endif // Q_OS_SYMBIAN

    Qt::WidgetAttribute attribute;
    switch (orientation) {
#if QT_VERSION < 0x040702
    // Qt < 4.7.2 does not yet have the Qt::WA_*Orientation attributes
    case ScreenOrientationLockPortrait:
        attribute = static_cast<Qt::WidgetAttribute>(128);
        break;
    case ScreenOrientationLockLandscape:
        attribute = static_cast<Qt::WidgetAttribute>(129);
        break;
    default:
    case ScreenOrientationAuto:
        attribute = static_cast<Qt::WidgetAttribute>(130);
        break;
#else // QT_VERSION < 0x040702
    case ScreenOrientationLockPortrait:
        attribute = Qt::WA_LockPortraitOrientation;
        break;
    case ScreenOrientationLockLandscape:
        attribute = Qt::WA_LockLandscapeOrientation;
        break;
    default:
    case ScreenOrientationAuto:
        attribute = Qt::WA_AutoOrientation;
        break;
#endif // QT_VERSION < 0x040702
    };
    setAttribute(attribute, true);
}

void MainWindow::showExpanded()
{
#ifdef Q_OS_SYMBIAN
    showFullScreen();
#elif defined(Q_WS_MAEMO_5) || defined(Q_WS_MAEMO_6)
    showMaximized();
#else
    show();
#endif
}
